/*

lidentd By Drago (Drago@Drago.com)
Code base: pidentd
Wild card matching functions (wildmat.c) : Rich $alz is now <rsalz@bbn.com>

You may use this code as you wish, just please give credit to the original
authors.

<Stuff>
greets to:
Bill Clinton, and Monica Lewinski - Keep up the good work.

Please email and let me know what you think of lidentd.
If you can suggest any new features please do so.

Report any bugs ('features' -microsoft).

yadda yadda yadda.
Space filler, moof moof.
</Stuff>

*/

#define EOL "\r\n"	/* Send as EOL */

#define LIDENTD_CONF "/etc/lidentd.conf"	/* Main lidentd configuration file */
#define LIDENTD_USER_CONF "lidentd.conf"	/* User configuration file (if they have access) */

#define CHAR_IP_SIZE 15+1	/* The size of an IP in character length */

#define PROC_TCP "/proc/net/tcp"	/* The file that stores tcp connection information */

#define LET_ME_RUN_AS_ROOT 0		/* Duh? */

#include <stdio.h>
#include <netdb.h>
#include <pwd.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>

#define RELEASE_DATE "10/02/98 18:14:25"
#define VERSION_HIGH "1"
#define VERSION_LOW "0"
#define VERSION_PATCH "p"

#define MAXARGS 10
#define MAXARGSLEN 500

static char *version="lidentd " VERSION_HIGH "." VERSION_LOW "p" VERSION_PATCH " " RELEASE_DATE " (Drago - Drago@Drago.com)";

typedef enum {FALSE=0, TRUE=1, LOCKFALSE=-2} BOOL;
typedef enum {USER=0, MAIN=1} FAKE_TYPE;

extern int wildmat(char *, char *);
void get_connection_info(void);
void error_exit(char *, ...);
void output_ident(void);
void get_request(void);
int fill_user(void);
int get_uid(void);
void process_ident(void);
char *getip(struct in_addr *);
char *gethost(struct in_addr *);
void cleanup(void);
void init(void);
void process_config(void);
char *parse_arg(char *, char, int);
char *realloc_char(char *);
void go_fake(char *, char *, char *, char *, char *, char *, char *, int);
void process_fake_config(FAKE_TYPE);
BOOL isalldigit(char *);
BOOL valid_characters(char *);
void write_syslog(char *, ...);
void output_debug_ident(void) ;
void write_debug(char *, ...); 
char *random_str(char *);
BOOL good_fake(char *, char *, int);
BOOL deny_user(char *);
BOOL in_passwd(char *);
void fake_user_config(void);
void handle_alarm(int);

FILE *configfp;

struct
{
	char valid_characters[256];
	BOOL debug;
	BOOL match_destination_connection;	/* Match the destination connection against the tcp proc file */
	BOOL match_from_connection;	/* Match the from connection against the proc tcp file */
	BOOL deny_fake_if_real;	/* Deny the use of the fake username if it exists in the passwd file */
	int timeout;
} options={"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789", FALSE, TRUE, FALSE, TRUE, 60};

struct
{
	char no_user[100];	/* Can't map a user to a port */
	char os[100];	/* The OS to send in the ident response */
	char unknown_error[100];	/* An unknown error */
	char invalid_port[100];	/* Output when the port number is 1 > or > 65535 */
	char hidden[100];	/* Output when the user asks to be hidden */
} responses={"NO-USER", "UNIX", "UNKNOWN-ERROR", "INVALID-PORT", "HIDDEN-USER"};

struct
{
	unsigned int destination_s_addr;
	unsigned int from_s_addr;
	int request_server_port;
	int request_client_port;

	char remote_ip[CHAR_IP_SIZE];
	char *remote_host;

	char local_ip[CHAR_IP_SIZE];
	char *local_host;

	char username[200];
	int uid;
	char dir[200];

	char *response;
	char *error;

	BOOL hidden;
	BOOL user_conf;
	
} connection;


int main(int argc, char **argv) 
{
	if (argc>1 && (argv[1][0]=='v' || argv[1][1]=='v'))
	{
		printf("%s\n", version);
		exit(0);
	}
#if !LET_ME_RUN_AS_ROOT
	if (getuid()==0)
	{
		error_exit("Don't run me as root you dork!");
	}
#endif
	signal(SIGALRM, handle_alarm);
	init();
	process_config();
	get_connection_info();
	alarm(options.timeout);
	get_request();
	alarm(0);
	connection.uid=get_uid();
	if (connection.uid==-1)
	{
		connection.error=responses.no_user;
		output_ident();
	}
	else
	{
		if (fill_user()<0)
		{
			error_exit("Error getting information on uid %s", connection.uid);
		}
		process_fake_config(MAIN);
		fake_user_config();
		if (connection.user_conf==TRUE) process_fake_config(USER);
		connection.response=connection.username;
		output_ident();
	}

	cleanup();
	return 0;
}

int fill_user(void)
{
	struct passwd *pwentry;
	while ((pwentry=getpwent())!=NULL)
	{
		if (pwentry->pw_uid==connection.uid)
		{
			strncpy(connection.username, pwentry->pw_name, 200);		
			strncpy(connection.dir, pwentry->pw_dir, 200);
			endpwent();
			return TRUE;
		}
	}
	endpwent();
	return FALSE;
}

void get_connection_info(void) 
{
	char *host;
	struct sockaddr_in sock;
	int size=sizeof(struct sockaddr_in);
	
	if (getpeername(0,(struct sockaddr *)&sock, &size)<0) 
	{
 		error_exit("getpeername");
	}
	connection.from_s_addr=sock.sin_addr.s_addr;
	strncpy(connection.remote_ip, getip(&sock.sin_addr), CHAR_IP_SIZE);
	host=gethost(&sock.sin_addr);
	if (host==NULL) {
		connection.remote_host=(char *) malloc(strlen(connection.remote_ip)+1);
		if (connection.remote_host==NULL) error_exit("Error allocating memory.");
		strncpy(connection.remote_host, connection.remote_ip, strlen(connection.remote_ip)+1);
	}
	else
	{
		connection.remote_host=(char *) malloc(strlen(host)+1);
		if (connection.remote_host==NULL) error_exit("Error allocating memory.");
		strncpy(connection.remote_host, host, strlen(host)+1);
	}

	if (getsockname(0,(struct sockaddr *)&sock,&size)<0)
	{
		error_exit("getsockname");
	}
	connection.destination_s_addr=sock.sin_addr.s_addr;
	strncpy(connection.local_ip, getip(&sock.sin_addr), CHAR_IP_SIZE);
	host=gethost(&sock.sin_addr);
	if (host==NULL)
	{
		connection.local_host=(char *) malloc(strlen(connection.local_ip)+1);
		if (connection.local_host==NULL) error_exit("Error allocating memory.");
		strncpy(connection.local_host, connection.local_ip, strlen(connection.local_ip)+1);
	}
	else
	{
		connection.local_host=(char *) malloc(strlen(host)+1);
		if (connection.local_host==NULL) error_exit("Error allocating memory.");
		strncpy(connection.local_host, host, strlen(host)+1);
	}

}
	
void error_exit(char *format, ...)
{
	char buffer[1024];
	va_list theargs;
	output_ident();	
	va_start(theargs, format);
	vsnprintf(buffer, 1024, format, theargs);
	write_syslog("%s : %s", buffer, strerror(errno));
	cleanup();
	exit(0);
}

void write_syslog(char *format, ...)
{
        char buffer[1024];
        va_list theargs;
        va_start(theargs, format);
        vsnprintf(buffer, 1024, format, theargs);
        syslog(LOG_INFO, "%s", buffer);
}

void write_debug(char *format, ...)
{
        char buffer[1024];
        va_list theargs;
	if (options.debug!=TRUE) return;
        va_start(theargs, format);
        vsnprintf(buffer, 1024, format, theargs);
        write_syslog("%s", buffer);
}


int get_uid(void)
{
	FILE *fp;
	char buf[132];
	struct in_addr myladdr, myraddr;
	int mylport, myrport;
	int uid;

	if ((fp = fopen(PROC_TCP, "r"))==NULL)
	{
		error_exit("Error opening tcp file (File=%s)", PROC_TCP);
   	}

	fgets(buf,sizeof(buf)-1,fp);
	while (fgets(buf, sizeof(buf)-1, fp))
	{
		if(sscanf(buf,"%*d: %lX:%x %lX:%x %*x %*lX:%*lX %*x:%*lX %*lx %d",
		&myladdr, &mylport, &myraddr, &myrport,
		&uid)==5)
		{
			if (options.match_destination_connection==TRUE)
				if (myladdr.s_addr!=connection.destination_s_addr)
					return -1;
			if (options.match_from_connection==TRUE)
				if (myraddr.s_addr!=connection.from_s_addr)
					return -1;
			if (mylport == connection.request_client_port && myrport == connection.request_server_port) 
			{
				fclose(fp);
				return uid;
			}
		}
	}
	fclose(fp);
	return -1;
}

void output_ident(void) 
{
	output_debug_ident();
	printf("%d , %d : ", connection.request_client_port, connection.request_server_port);

	if (connection.response==NULL)
	{
		connection.response=connection.username;
	}

	if ( (connection.username[0]!='\0' && connection.response==NULL) )
		connection.response=connection.username;

	if (connection.response[0]=='\0') connection.response=NULL;

	if (connection.error!=NULL || connection.response==NULL) 
	{
		printf("ERROR : ");
		if (connection.error==NULL)
			printf("%s", responses.unknown_error);
		else
			printf("%s", connection.error);
	}
	else
	{
		printf("USERID : %s :%s", responses.os, connection.response);
	}
	printf("%s", EOL);
	if (!(connection.error!=NULL || connection.response==NULL))
		write_syslog("%d , %d : response=%s username=%s", connection.request_client_port, connection.request_server_port, connection.response, connection.username);
	return;
}			

void output_debug_ident(void) 
{
	char build[1024];
	if (options.debug!=TRUE) return;
	snprintf(build, 1024, "%d , %d : ", connection.request_client_port, connection.request_server_port);

	if (connection.response==NULL)
	{
		connection.response=connection.username;
	}

	if ( (connection.username[0]!='\0' && connection.response==NULL) ) connection.response=connection.username;

	if (connection.error!=NULL || connection.response==NULL) 
	{
		snprintf(build, 1024, "%s%s", build, "ERROR : ");
		if (connection.error==NULL)
			snprintf(build, 1024, "%s%s", build, responses.unknown_error);
		else
			snprintf(build, 1024, "%s%s", build, connection.error);
	}
	else
	{
		snprintf(build, 1024, "%sUSERID : %s :%s", build, responses.os, connection.response);
	}
	write_debug("%s", build);
	return;
}
	
void get_request(void) 
{
	char line[100];
	int ret;
	if (fgets(line, 100, stdin)==NULL) 
	{
		output_ident();
		exit(0);
	}
	ret=sscanf(line, "%d , %d", &connection.request_client_port, &connection.request_server_port);
	write_debug("%d , %d : Recieved request", connection.request_client_port, connection.request_server_port);
	if (ret!=2 || connection.request_server_port > 65535 || connection.request_server_port < 1) connection.request_server_port=0;
	if (ret!=2 || connection.request_client_port > 65535 || connection.request_client_port < 1) connection.request_client_port=0;
	if (connection.request_server_port==0 || connection.request_client_port==0)
	{
		connection.request_server_port=connection.request_client_port=0;
		connection.error=responses.invalid_port;
		output_ident();
		exit(0);
	}
}
	 		 

char *gethost(struct in_addr *addr)
{
  struct hostent *hp;

  hp = gethostbyaddr((char *)addr, sizeof(struct in_addr), AF_INET);
  if (hp) return hp->h_name;
  else return NULL;
}

char *getip(struct in_addr *addr)
{
  return inet_ntoa(*addr);
}

void cleanup(void)
{
	if (connection.remote_host!=NULL) free(connection.remote_host);
	if (connection.local_host!=NULL) free(connection.local_host);
	closelog();
}

void init(void)
{
	configfp=fopen(LIDENTD_CONF, "r");

	if (configfp==NULL)
	{
		error_exit("Error opening main configuration (File=%s)", LIDENTD_CONF);
	}

	connection.destination_s_addr=0;
	connection.from_s_addr=0;
	connection.request_server_port=0;
	connection.request_client_port=0;

	memset(connection.remote_ip, '\0', CHAR_IP_SIZE);
	connection.remote_host=NULL;

	memset(connection.local_ip, '\0', CHAR_IP_SIZE);

	memset(connection.username, '\0', 200);
	memset(connection.dir, '\0', 200);

	connection.local_host=NULL;

	connection.uid=-1;

	connection.response=NULL;
	connection.error=NULL;

	connection.user_conf=FALSE;
	connection.hidden=FALSE;
	openlog("lidentd", LOG_PID|LOG_CONS, LOG_USER);
}


void process_config(void)
{
	char line[1024];
	int linenum=0;
	int c;

	rewind(configfp);

	while (1)
	{
		char args[MAXARGS][MAXARGSLEN]={{'\0'}};
		int argsc=0;
		char *ptr;
		BOOL set=TRUE;
		int loop;
		memset(args, '\0', MAXARGS*MAXARGSLEN);
		argsc=0;
		c=fgetc(configfp);
		if (c==EOF) break;
		if (c=='!') set=FALSE;
		else ungetc(c, configfp);
		
		if (fgets(line, 1024, configfp)==NULL) break;
		linenum++;
		if (line[strlen(line)-1]=='\n') line[strlen(line)-1]='\0'; 
		if (c=='#') continue;
		loop=0;

		while (loop<MAXARGS && (ptr=parse_arg(line, ':', loop))!=NULL)
		{
			argsc++;
			strncpy(args[loop], ptr, MAXARGSLEN);
			free(ptr);
			loop++;
		}

		if (!strncasecmp(args[0], "set", 100))
		{
			if (args[2][0]=='\0')
			{
				error_exit("Need a value for variable: %s (File=%s, Line=%d)", args[1], LIDENTD_CONF, linenum);
			}
			if (!strncasecmp(args[1], "valid_characters", 100))
			{
				strncpy(options.valid_characters, args[2], 256);
			}
			else if (!strncasecmp(args[1], "debug", 100))
			{
				if (toupper(args[2][0])=='T' || args[2][0]=='1') options.debug=TRUE;
				else if (toupper(args[2][0])=='F' || args[2][0]=='0') options.debug=FALSE;
				else error_exit("Invalid value %s for variable %s (File=%s, Line=%d)", args[2], args[1], LIDENTD_CONF, linenum);
			}
			else if (!strncasecmp(args[1], "timeout", 100))
			{
				if (isalldigit(args[2])==FALSE)
					error_exit("You must specify an integer value for variable %s (File=%s, Line=%d)", args[1], LIDENTD_CONF, linenum);
				options.timeout=atoi(args[2]);
			}
			else if (!strncasecmp(args[1], "deny_fake_if_real", 100))
			{
				if (toupper(args[2][0])=='T' || args[2][0]=='1') options.deny_fake_if_real=TRUE;
				else if (toupper(args[2][0])=='F' || args[2][0]=='0') options.deny_fake_if_real=FALSE;
				else error_exit("Invalid value %s for variable %s (File=%s, Line=%d)", args[2], args[1], LIDENTD_CONF, linenum);
			}
			else if (!strncasecmp(args[1], "no_user", 100))
			{
				strncpy(responses.no_user, args[2], 100);
			}
			else if (!strncasecmp(args[1], "os", 100))
			{
				strncpy(responses.os, args[2], 100);
			}
			else if (!strncasecmp(args[1], "unknown_error", 100))
			{
				strncpy(responses.unknown_error, args[2], 100);
			}
			else if (!strncasecmp(args[1], "invalid_port", 100))
			{
				strncpy(responses.invalid_port, args[2], 100);
			}
			else if (!strncasecmp(args[1], "match_destination_connection", 100))
			{
				if (toupper(args[2][0])=='T' || args[2][0]=='1') options.match_destination_connection=TRUE;
				else if (toupper(args[2][0])=='F' || args[2][0]=='0') options.match_destination_connection=FALSE;
				else error_exit("Invalid value %s for variable %s (File=%s, Line=%d)", args[2], args[1], LIDENTD_CONF, linenum);
			}
			else if (!strncasecmp(args[1], "match_from_connection", 100))
			{
				if (toupper(args[2][0])=='T' || args[2][0]=='1') options.match_from_connection=TRUE;
				else if (toupper(args[2][0])=='F' || args[2][0]=='0') options.match_from_connection=FALSE;
				else error_exit("Invalid value %s for variable %s (File=%s, Line=%d)", args[2], args[1], LIDENTD_CONF, linenum);
			}
			else
			{
				error_exit("Invalid variable: %s (File=%s, Line=%d)", args[1], LIDENTD_CONF, linenum);
			}
		}
	}
}

void fake_user_config(void)
{
	char line[1024];
	int linenum=0;
	int c;

	rewind(configfp);

	while (1)
	{
		char args[MAXARGS][MAXARGSLEN]={{'\0'}};
		int argsc=0;
		char *ptr;
		BOOL set=TRUE;
		int loop;
		memset(args, '\0', MAXARGS*MAXARGSLEN);
		argsc=0;
		c=fgetc(configfp);
		if (c==EOF) break;
		if (c=='!') set=FALSE;
		else ungetc(c, configfp);
		
		if (fgets(line, 1024, configfp)==NULL) break;
		linenum++;
		if (line[strlen(line)-1]=='\n') line[strlen(line)-1]='\0'; 
		if (c=='#') continue;
		loop=0;

		while (loop<MAXARGS && (ptr=parse_arg(line, ':', loop))!=NULL)
		{
			argsc++;
			strncpy(args[loop], ptr, MAXARGSLEN);
			free(ptr);
			loop++;
		}

		if (!strncasecmp(args[0], "userconf", 100) && connection.user_conf!=LOCKFALSE)
		{
			char tmp[20];

			if (connection.uid!=-1)
			{
				snprintf(tmp, 20, "%d", connection.uid);
				if (wildmat(tmp, args[1])==TRUE)
				{
					if (set==FALSE) set=LOCKFALSE;
					connection.user_conf=set;
				}
			}

			if (connection.username != NULL)
			if (wildmat(args[1], connection.username)==TRUE)
			{
				if (set==FALSE) set=LOCKFALSE;
				connection.user_conf=set;
			}
		}
	}
}

BOOL deny_user(char *user)
{
	char line[1024];
	int linenum=0;
	int c;

	rewind(configfp);

	while (1)
	{
		char args[MAXARGS][MAXARGSLEN]={{'\0'}};
		int argsc=0;
		char *ptr;
		BOOL set=TRUE;
		int loop;
		memset(args, '\0', MAXARGS*MAXARGSLEN);
		argsc=0;
		c=fgetc(configfp);
		if (c==EOF) break;
		if (c=='!') set=FALSE;
		else ungetc(c, configfp);

		if (fgets(line, 1024, configfp)==NULL) break;
		linenum++;
		if (line[strlen(line)-1]=='\n') line[strlen(line)-1]='\0'; 
		if (c=='#') continue;
		loop=0;

		while (loop<MAXARGS && (ptr=parse_arg(line, ':', loop))!=NULL)
		{
			argsc++;
			strncpy(args[loop], ptr, MAXARGSLEN);
			free(ptr);
			loop++;
		}

		if (!strncasecmp(args[0], "allowfake", 100))
		{
			if (args[1][0]=='\0')
			{
				error_exit("Need a username to deny for allowfake (File=%s, Line=%d)", LIDENTD_CONF, linenum);
			}
			if (wildmat(user, args[1])==TRUE)
			{
				return (set==TRUE?FALSE:TRUE); 
			}
		}

	}
	return FALSE;
}

void process_fake_config(FAKE_TYPE type)
{
	char configfile[1024];
	char line[1024];
	int linenum=0;
	int c;
	FILE *fp;

	if (type==USER)
	{
		snprintf(configfile, 1024, "%s/%s", connection.dir, LIDENTD_USER_CONF);
		fp=fopen(configfile, "r");
	}
	else
	{
		snprintf(configfile, 1024, "%s", LIDENTD_CONF);
		fp=configfp;
		rewind(fp);
	}
	if (fp==NULL)
	{
		write_debug("%d , %d : Error opening: %s", connection.request_client_port, connection.request_server_port, configfile);
		return;
	}
	write_debug("%d , %d : open'd fake config: %s", connection.request_client_port, connection.request_server_port, configfile);

	while (1)
	{
		char args[MAXARGS][MAXARGSLEN]={{'\0'}};
		int argsc=0;
		char *ptr;
		BOOL set=TRUE;
		int loop;
		memset(args, '\0', MAXARGS*MAXARGSLEN);
		argsc=0;
		c=fgetc(fp);
		if (c==EOF) break;
		if (c=='!') set=FALSE;
		else ungetc(c, fp);
		
		if (fgets(line, 1024, fp)==NULL) break;
		linenum++;
		if (line[strlen(line)-1]=='\n') line[strlen(line)-1]='\0'; 
		if (c=='#') continue;
		loop=0;

		while (loop<MAXARGS && (ptr=parse_arg(line, ':', loop))!=NULL)
		{
			argsc++;
			strncpy(args[loop], ptr, MAXARGSLEN);
			free(ptr);
			loop++;
		}

		if (!strncasecmp(args[0], "fake", 100))
		{
			if (type==USER)
			{
				if (argsc!=6)
				{
					error_exit("Too %s args for fake (File=%s, Line=%d)", (argsc>6?"many":"few"), configfile, linenum);
				}
				go_fake("*", args[1], args[2], args[3], args[4], random_str(args[5]), configfile, linenum);
			}
			else
			{
				if (argsc!=7)
				{
					error_exit("Too %s args for fake (File=%s, Line=%d)", (argsc>6?"many":"few"), configfile, linenum);
				}
				go_fake(args[1], args[2], args[3], args[4], args[5], random_str(args[6]), configfile, linenum);
			}
		}
	}
	if (type==USER) fclose(fp);
}

char *parse_arg(char *string, char delim, int argn)
{
	int count=0;
	int i, len;
	char *arg=NULL;
	len=strlen(string)+1;
	for (i=0; i<len; i++)
	{
		if (arg==NULL) arg=(char *) calloc(1, sizeof(char));
		if (arg==NULL) error_exit("Error allocating memory");
		arg=realloc_char(arg);
		arg[strlen(arg)]=string[i];
		if ((string[i]==delim || string[i]=='\0'))
		{
			if (arg[strlen(arg)-2]=='\\')
			{
				arg[strlen(arg)-2]=delim;
				arg[strlen(arg)-1]='\0';
				continue;
			}
			if (count==argn)
			{
				if (arg[strlen(arg)-1]==delim) arg[strlen(arg)-1]=0;
				return arg;
			}
			free(arg);
			arg=NULL;
			count++;
		}
	}
	return NULL;
}



char *realloc_char(char *allocs)
{
   int lens=strlen(allocs);
   allocs=(char *) realloc(allocs, sizeof(char) + (lens*sizeof(sizeof(char))));
   if (allocs==NULL)
	error_exit("Error allocating memory");
   allocs[lens+1]='\0';
   return allocs;
}

void go_fake(char *foruser, char *myip, char *theirip, char *myport, char *theirport, char *username, char *file, int line)
{
	int idx;
	char *arg;
	int match;
	int tmp;
	char uid[20];
	char op='=';
	snprintf(uid, 20, "%d", connection.uid);
	match=FALSE; idx=0;
	while ((arg=parse_arg(foruser, ',', idx))!=NULL)
	{
		BOOL inc=FALSE;
		op='=';
		if (arg[0]=='>') { op='>'; inc=TRUE; }
		else if (arg[0]=='<') { op='<'; inc=TRUE; }
		else if (arg[0]=='=') { op='='; inc=TRUE; }

		if (isalldigit((inc==TRUE?arg+1:arg))==TRUE)
		{
			BOOL good=FALSE;
			tmp=atoi(arg);
			if (op=='=' && tmp==connection.uid) good=TRUE;
			else if (op=='>' && connection.uid>tmp) good=TRUE;
			else if (op=='<' && connection.uid<tmp) good=TRUE;

			if (good==TRUE)
			{
				free(arg);
				match=TRUE;
				break;
			}
		
		}

		else if (wildmat(connection.username, arg)==TRUE || wildmat(uid, arg)==TRUE)
		{
			free(arg);
			match=TRUE;
			break;	
		}
		free(arg);
		idx++;
	}
	if (match==FALSE) return;

	match=FALSE; idx=0;
	while ((arg=parse_arg(myip, ',', idx))!=NULL)
	{
		if (wildmat(connection.local_ip, arg)==TRUE)
		{
			free(arg);
			match=TRUE;
			break;	
		}
		if (wildmat(connection.local_host, arg)==TRUE)
		{
			free(arg);
			match=TRUE;
			break;	
		}
		free(arg);
		idx++;
	}
	if (match==FALSE) return;

	match=FALSE; idx=0;
	while ((arg=parse_arg(theirip, ',', idx))!=NULL)
	{
		if (wildmat(connection.remote_ip, arg)==TRUE)
		{
			free(arg);
			match=TRUE;
			break;	
		}
		if (wildmat(connection.remote_host, arg)==TRUE)
		{
			free(arg);
			match=TRUE;
			break;	
		}
		free(arg);
		idx++;
	}
	if (match==FALSE) return;

	match=FALSE; idx=0;
	while ((arg=parse_arg(myport, ',', idx))!=NULL)
	{
		char tmpport[20];
		BOOL inc=FALSE;
		char *from;
		char *to;
		op='=';

		if (arg[0]=='>') { op='>'; inc=TRUE; }
		else if (arg[0]=='<') { op='<'; inc=TRUE; }
		else if (arg[0]=='=') { op='='; inc=TRUE; }
		snprintf(tmpport, 20, "%d", connection.request_client_port);

		from=parse_arg(arg, '-', 0);
		to=parse_arg(arg, '-', 1);

		if (from!=NULL && to!=NULL)
		{
			if (isalldigit(from) && isalldigit(to))
			{
				int fromint, toint;
				fromint=atoi(from);
				toint=atoi(to);
				if ((connection.request_client_port <= toint) 
				&& (connection.request_client_port >= fromint))
				{
					free(arg);
					match=TRUE;
					break;
				}
			}
		}

		if (isalldigit((inc==TRUE?arg+1:arg))==TRUE)
		{
			BOOL good=FALSE;
			tmp=atoi(arg);

			if (op=='=' && tmp==connection.request_client_port) good=TRUE;
			else if (op=='>' && connection.request_client_port>tmp) good=TRUE;
			else if (op=='<' && connection.request_client_port<tmp) good=TRUE;

			if (good==TRUE)
			{
				free(arg);
				match=TRUE;
				break;
			}
		
		}

		else if (wildmat(tmpport, arg)==TRUE)
		{
			free(arg);
			match=TRUE;
			break;	
		}
		free(arg);
		idx++;
	}
	if (match==FALSE) return;

	match=FALSE; idx=0;
	while ((arg=parse_arg(theirport, ',', idx))!=NULL)
	{
		char tmpport[20];
		BOOL inc=FALSE;
		char *from;
		char *to;
		op='=';

		if (arg[0]=='>') { op='>'; inc=TRUE; }
		else if (arg[0]=='<') { op='<'; inc=TRUE; }
		else if (arg[0]=='=') { op='='; inc=TRUE; }
		snprintf(tmpport, 20, "%d", connection.request_server_port);

		from=parse_arg(arg, '-', 0);
		to=parse_arg(arg, '-', 1);

		if (from!=NULL && to!=NULL)
		{
			if (isalldigit(from) && isalldigit(to))
			{
				int fromint, toint;
				fromint=atoi(from);
				toint=atoi(to);
				if ((connection.request_server_port <= toint) 
				&& (connection.request_server_port >= fromint))
				{
					free(arg);
					match=TRUE;
					break;
				}
			}
		}

		if (isalldigit((inc==TRUE?arg+1:arg))==TRUE)
		{
			BOOL good=FALSE;
			tmp=atoi(arg);

			if (op=='=' && tmp==connection.request_server_port) good=TRUE;
			else if (op=='>' && connection.request_server_port>tmp) good=TRUE;
			else if (op=='<' && connection.request_server_port<tmp) good=TRUE;

			if (good==TRUE)
			{
				free(arg);
				match=TRUE;
				break;
			}
		
		}

		else if (wildmat(tmpport, arg)==TRUE)
		{
			free(arg);
			match=TRUE;
			break;	
		}
		free(arg);
		idx++;
	}
	if (match==FALSE) return;

	if (good_fake(username, file, line)==FALSE) return;
	if (username[0]=='\0')
	{
		connection.response=NULL;
		connection.error=responses.hidden;
	}
	else
	{
		connection.response=username;
		connection.error=NULL;
	}
	output_ident();
	cleanup();
	exit(0);	
}


BOOL isalldigit(char *str)
{
	while (*str)
	{
		if (*str!='0' && *str!='1' && *str!='2' && *str!='3' && *str!='4' && *str!='5' && *str!='6' && *str!='7' && *str!='8' && *str!='9' && *str!='-') return FALSE;
		*str++;
	}
	return TRUE;
}

BOOL valid_characters(char *str)
{
	BOOL good;
	while (*str)
	{
		char *tmp=options.valid_characters;
		good=FALSE;
		while (*tmp)
		{
			if (*str==*tmp)
			{
				good=TRUE;			
				break;
			}
			*tmp++;
		}
		if (good==FALSE) return FALSE;
		*str++;
	}
	return TRUE;
}

char *random_str(char *str)
{
	char *arg;
	int idx=0, randidx;
	while ((arg=parse_arg(str, ',', idx))!=NULL)
	{
		idx++;
	}
	srand(time(NULL) * getpid() * getppid());
	randidx=(rand()%idx);
	arg=parse_arg(str, ',', randidx);
	return arg;
}

BOOL good_fake(char *fakeuser, char *file, int line)
{
	if (valid_characters(fakeuser)==FALSE)
	{
		write_syslog("Skipping fake user due to invalid characters in fake username (File=%s, Line=%d)", file, line);
		return FALSE;
	}

	if (deny_user(fakeuser)==TRUE)
	{
		write_syslog("Skipping fake user due to a match in the deny user's in (File=%s, Line=%d)", file, line);
		return FALSE;
	}

	if (options.deny_fake_if_real==TRUE && in_passwd(fakeuser)==TRUE)
	{
		write_syslog("Skipping fake user %s because the user is in the password file (File=%s, Line=%d)", fakeuser, file, line);
		return FALSE;
	}
	
	return TRUE;
}

BOOL in_passwd(char *user)
{
	struct passwd *pwentry;
	if (user==NULL) return FALSE;

	while ((pwentry=getpwent())!=NULL)
	{
		if (!strncasecmp(pwentry->pw_name, user, strlen(pwentry->pw_name)))
		{
			if (!strncasecmp(pwentry->pw_name, connection.username, strlen(pwentry->pw_name))) continue;
			endpwent();
			return TRUE;
		}
	}
	endpwent();
	return FALSE;
}

void handle_alarm(int muff)
{
	error_exit("Timeout");
}

